/*
  Prime number generator.

  Copyright 1999, R.Harmsen
*/
#include <stdio.h>
#include <string.h>
#if !defined(_Windows) && !defined (__MSDOS__)
  #include <sys/types.h>
  #include <unistd.h>
#endif
#include <stdlib.h>
#include <math.h>
#include <errno.h>

typedef long longtype;

int  userinput (void);
void showform (char *script, longtype x, longtype t);
void htmlhead (void);
void htmlfoot (void);
void showprime (longtype x);
void getparms (int len, longtype *px, longtype *pt);
void calcprimes (longtype x, longtype t);

char *ContentLength = "CONTENT_LENGTH";

int main (void)
{
   longtype x = 2;
   longtype t = 1000;
   int len;
   char *scriptname = "../cgi-bin/prmcgi.cgi";

   #if !defined(_Windows) && !defined (__MSDOS__)
      nice(10);
   #endif

   if ((len = userinput()) == 0)
   {
      htmlhead();
      showform(scriptname, x, t);
      htmlfoot();
   }
   else
   {
      getparms(len, &x, &t);
      htmlhead();
      showform(scriptname, x, t);
      calcprimes(x, t);
      htmlfoot();
   }

   return 0;
}

int userinput (void)
{
   int l;

   if (getenv(ContentLength) &&
      (l = atoi(getenv(ContentLength))) > 0)
   {
      return l;
   }
   else
      return 0;
}

void showform (char *script, longtype x, longtype t)
{
   printf(
      "<p class=pagelink>\n"
      "<a target=_top href=\"../index/math.htm\">Math menu</a>\n"
      "<a target=_top href=\"../index/menu.htm\">Main menu</a>\n"
      "</p>");

   printf(
      "<FORM ACTION=\"%s\" METHOD=POST>\n"
      "This is the CGI-version.<br><br>\n"
      "Enter the smallest prime number you want to find,\n"
      "and how many numbers should be tested on being prime\n"
      "(this is limited to 1000000 to avoid overloading the\n"
      "server computer; and the program runs at a lower priority).\n"
      "<br><br>\n"
      "<INPUT TYPE=Text NAME=LowBound SIZE=10 MAXLENGTH=10 VALUE=%ld>\n"
      "<br>\n"
      "<INPUT TYPE=Text NAME=Range SIZE=10 MAXLENGTH=10 VALUE=%ld>\n"
      "<br><br>\n"
      "<INPUT TYPE=submit VALUE=\"Start calculation\">\n"
      "<br>\n"
      "</FORM>\n\n",
      script, x, t);
}

void htmlhead (void)
{
   printf(
      "Content-type: text/html\n\n"
      "<!doctype html>\n"
      "<html>\n"
      "<head>\n"
      "<title>Prime number calculation</title>\n"
      "<meta name=viewport content=\"width=device-width, initial-scale=1\">\n"
      "<link rel=stylesheet href=\"../css/lingtic2.css\">\n"
      "<link rel=stylesheet href=\"../cgi-bin/colschem.cgi\">\n"
      "<style>body {margin: 10px;}</style>\n"
      "</head><body>\n"
      );
   fflush(stdout);
}

void htmlfoot (void)
{
   printf("</body>\n</html>\n");
   fflush(stdout);
}

void showprime (longtype x)
{
   fprintf(stdout, "%ld", x);
   fprintf(stdout, " ");
}

void getparms (int len, longtype *px, longtype *pt)
{
   char *buf = calloc(len, 1);
   char *eq1, *eq2;

   /* Defaults */
   *px = 2;
   *pt = 1000;

   if (!buf ||
      fread(buf, len, 1, stdin) != 1)
   {
      free(buf);
      return;
   }

   eq1 = strchr(buf, '=');
   if (!eq1)
   {
      free(buf);
      return;
   }

   eq2 = strchr(eq1 + 1, '=');
   if (!eq2)
   {
      free(buf);
      return;
   }

   *px = atol(eq1 + 1);
   *pt = atol(eq2 + 1);

   if (*px < 2)
       *px = 2;

   /* Limit resources */
   if (*pt > 1000000)
       *pt = 1000000;

   free(buf);
}

void calcprimes (longtype x, longtype t)
{
   longtype d, m;
   int p;

   t += x;
   x += 6;
   x -= x % 6;
   x--;
   if (x < 23)
   {
      showprime(2);
      showprime(3);
      showprime(5);
      showprime(7);
      showprime(11);
      showprime(13);
      showprime(17);
      showprime(19);
      x = 23;
   }
   for (; x < t; x += 4)
   {
      m = (longtype) sqrt (x) +  2;
      d = 5;
      p = 1;
      for (; p && d < m; d += 6)
         if (x % d == 0 || x % (d + 2) == 0)
            p = 0;
      if (p)
         showprime(x);

      x += 2;
      d = 5;
      p = 1;
      for (; p && d < m; d += 6)
	       if (x % d == 0 || x % (d + 2) == 0)
            p = 0;
      if (p)
         showprime(x);
   }
}
